games/urls.py
from django.urls import path
from games.views import (
    CharacterDetailView,
    GameListView,
    GameDetailView,
    GameCreateView,
    GameDeleteView,
    GameUpdateView,
    CharacterCreateView,
    CharacterDetailView,
    CharacterUpdateView
)

urlpatterns = [
    path("", GameListView.as_view(), name="list_games"),
    path("<int:pk>/", GameDetailView.as_view(), name="show_game"),
    path("create/", GameCreateView.as_view(), name="create_game"),
    path("<int:pk>/delete/", GameDeleteView.as_view(), name="delete_game"),
    path("<int:pk>/update/", GameUpdateView.as_view(), name="update_game"),


    path("<int:game_id>/character/create/", CharacterCreateView.as_view(), name="create_character"),
    path("character/<int:pk>/", CharacterDetailView.as_view(), name="detail_character"),
    path("character/<int:pk>/edit/", CharacterUpdateView.as_view(), name="update_character"),
]

player/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic.base import RedirectView

urlpatterns = [
    path("admin/", admin.site.urls),
    path("games/", include("games.urls")),
    path("goals/", include("goals.urls")),
    path("accounts/", include("accounts.urls")),
    path("", RedirectView.as_view(url="/games/"), name="home"),
]

games/models.py
from django.db import models
from django.forms import CharField
from django.urls import reverse_lazy

from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

CLASS_CHOICES = [
    ('Artificer', 'Artificer'),
    ('Barbarian', 'Barbarian'),
    ('Bard', 'Bard'),
    ('Cleric', 'Cleric'),
    ('Druid', 'Druid'),
    ('Fighter', 'Fighter'),
    ('Monk', 'Monk'),
    ('Paladin', 'Paladin'),
    ('Ranger', 'Ranger'),
    ('Rogue', 'Rogue'),
    ('Sorcerer', 'Sorcerer'),
    ('Warlock', 'Warlock'),
    ('Wizard', 'Wizard'),
]


# Create your models here.
class Game(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(USER_MODEL, related_name="games")
    user = models.ForeignKey(USER_MODEL, related_name="created_games", on_delete=models.CASCADE)

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse_lazy("show_games", kwargs={"pk": self.pk})

class Character(models.Model):
    summary = models.TextField()
    name = models.CharField(max_length=100)
    playersclass = models.CharField(choices=CLASS_CHOICES, max_length=50, default='Artificer')
    user = models.ForeignKey(USER_MODEL, related_name="characters", on_delete=models.CASCADE)
    game = models.ForeignKey("Game", related_name="characters", on_delete=models.CASCADE)


    def __str__(self):
        return self.name


        

games/views.py
from django.shortcuts import redirect
from django.urls import reverse, reverse_lazy
from django.views.generic import ListView, DetailView, CreateView, UpdateView, DeleteView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy

from games.models import Game, Character

# Create your views here.

# === Game Views ===
class GameListView(LoginRequiredMixin, ListView):
    model = Game
    template_name = "games/list_games.html"

    def get_queryset(self):
        return Game.objects.filter(members=self.request.user)


class GameDetailView(LoginRequiredMixin, DetailView):
    model = Game
    template_name = "games/detail_game.html"
    context_object_name = "game_detail"

class GameCreateView(LoginRequiredMixin, CreateView):
    model = Game
    template_name = "games/create_game.html"
    fields = ["name", "description", "members"]

    def form_valid(self, form):
        game = form.save(commit=False)
        game.user = self.request.user
        game.save()
        form.save_m2m()
        return redirect("show_game", pk=game.id)


class GameDeleteView(LoginRequiredMixin, DeleteView):
    model = Game
    template_name = "games/delete_game.html"
    success_url = reverse_lazy("home")
    context_object_name = "game_delete"

class GameUpdateView(LoginRequiredMixin, UpdateView):
    model = Game
    template_name = "games/update_game.html"
    context_object_name = "game_update"
    fields = ["name", "description", "members"]

    def get_success_url(self):
        return reverse_lazy("show_game", args=[self.object.id])
    
# === Character Views ===
class CharacterDetailView(LoginRequiredMixin, DetailView):
    model = Character
    template_name = "characters/detail_character.html"
    context_object_name = "character_detail"

class CharacterCreateView(LoginRequiredMixin, CreateView):
    model = Character
    template_name = "characters/create_character.html"
    fields = ["name", "summary", "playersclass"]


    def form_valid(self, form):
        character = form.save(commit=False)
        game_id = self.kwargs["game_id"]
        game = Game.objects.get(id=game_id)
        character.user = self.request.user
        character.game = game
        character.save()
        form.save_m2m()
        return redirect("detail_character", pk=character.id)


class CharacterUpdateView(LoginRequiredMixin, UpdateView):
    model = Character
    template_name = "characters/update_character.html"
    context_object_name = "character_update"
    fields = ["name", "summary", "playersclass"]

    def get_success_url(self):
        return reverse_lazy("detail_character", args=[self.object.id])

games/templates/games/create_game.html
{% extends 'base.html' %}

{% block content %}

<div>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="sumbit">Create Game</button>
    </form>
</div>

{% endblock content %}

games/templates/games/delete_game.html
{% extends 'base.html' %}

{% block content %}
<div class="form">
    <form method="POST">
        {% csrf_token %}
        <p>Do you want to delete "{{ game_delete.name }}"?</p>
        <button type="submit">Delete</button>
    </form>
</div>
{% endblock content %}

games/templates/games/detail_game.html
{% extends 'base.html' %}

{% block content %}

<div class="games-container">
    <h1>{{ game_detail.name }}</h1>

    <div class="game-description">
        <p>{{ game_detail.description }}</p>
    </div>

    <hr>
    <div class="game-character-navigation">

        <div>
            <button><a href="{% url 'create_character' game_detail.id %}">Create Character</a></button>
        </div>

        {% if game_detail.user == user %}
            <div>
                <button><a href="{% url 'update_game' game_detail.id %}">Update Game</a></button>
            </div>
            <div>
                <button><a href="{% url 'delete_game' game_detail.id %}">Delete Game</a></button>
            </div>
        {% endif %}
    </div>
    <hr>
    <h2>Adventuring Party</h2>

    <div class="characters">
    {% for character in game_detail.characters.all %}
        <a href="{% url 'detail_character' character.id %}" class="single-character">{{ character.name }} - {{ character.playersclass }}</a>
        
    {% endfor %}
</div>

{% endblock content %}

games/templates/games/list_games.html
{% extends 'base.html' %}

{% block content %}
    <div class="games-container">
        {% for game in game_list %}
            <div class="single-game-container">
                <li class="games">
                    <i class="fa-solid fa-dragon"></i><a href="{% url 'show_game' game.id %}">{{ game.name }}</a>
                </li>
                {% if game.user == user %}
                    <span class="button"><a href="{% url 'delete_game' game.id %}">Delete Game</a></span>
                {% endif %}
            </div>
        {% endfor %}
    </div>
{% endblock content %}
    

games/templates/games/update_game.html
{% extends 'base.html' %}

{% block content %}

<div>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit">Update</button>
    </form>
</div>

{% endblock content %}